export interface SuccessType<D> {
    caught: false;
    value: D;
}
export interface FailureType<E> {
    caught: true;
    value: E;
}
export declare type ResultType<D, E> = SuccessType<D> | FailureType<E>;
export declare function tryAsync<D = any, E = any>(target: (...args: any[]) => Promise<D>, ...args: any[]): Promise<ResultType<D, E>>;
export declare function tryAsync<D = any, E = any>(target: Promise<D>): Promise<ResultType<D, E>>;
/**
 * Synchronous version.
 *
 * @param fn    - Function.
 * @param args  - Optional list of arguments.
 *
 * @return {Promise}
 */
export declare function trySync<T = any, U = any>(fn: (...args: any[]) => T, ...args: any[]): ResultType<T, U>;
