'use strict';

// A type of promise-like that resolves synchronously and supports only one observer

const _iteratorSymbol = /*#__PURE__*/ typeof Symbol !== "undefined" ? (Symbol.iterator || (Symbol.iterator = Symbol("Symbol.iterator"))) : "@@iterator";

const _asyncIteratorSymbol = /*#__PURE__*/ typeof Symbol !== "undefined" ? (Symbol.asyncIterator || (Symbol.asyncIterator = Symbol("Symbol.asyncIterator"))) : "@@asyncIterator";

// Asynchronously call a function and send errors to recovery continuation
function _catch(body, recover) {
	try {
		var result = body();
	} catch(e) {
		return recover(e);
	}
	if (result && result.then) {
		return result.then(void 0, recover);
	}
	return result;
}

/**
 * Asynchronous version.
 *
 * @param target  - Promise or an asynchronous function.
 * @param args    - Optional list of arguments (for async func).
 *
 * @return {Promise}
 */
var tryAsync = function tryAsync(target) {
  for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }

  try {
    var _temp3 = function _temp3(_result) {
      return _exit2 ? _result : target.then(function (d) {
        return {
          caught: false,
          value: d
        };
      })["catch"](function (e) {
        return {
          caught: true,
          value: e
        };
      });
    };

    var _exit2 = false;

    var _temp4 = function () {
      if (typeof target === 'function') {
        return _catch(function () {
          return Promise.resolve(target.apply(null, args)).then(function (value) {
            _exit2 = true;
            return {
              caught: false,
              value: value
            };
          });
        }, function (e) {
          _exit2 = true;
          return {
            caught: true,
            value: e
          };
        });
      }
    }();

    // If target is an async function then
    // apply optional arguments and execute
    return Promise.resolve(_temp4 && _temp4.then ? _temp4.then(_temp3) : _temp3(_temp4)); // If target is already a baked
    // promise then just wrap it up
  } catch (e) {
    return Promise.reject(e);
  }
};
/**
 * Synchronous version.
 *
 * @param fn    - Function.
 * @param args  - Optional list of arguments.
 *
 * @return {Promise}
 */

function trySync(fn) {
  try {
    for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
      args[_key2 - 1] = arguments[_key2];
    }

    var value = fn.apply(null, args);
    return {
      caught: false,
      value: value
    };
  } catch (e) {
    return {
      caught: true,
      value: e
    };
  }
}

exports.tryAsync = tryAsync;
exports.trySync = trySync;
//# sourceMappingURL=try-catch-js.cjs.development.js.map
